#version 130

uniform mat4 u_ProjectionMatrix = mat4(1.0);
uniform mat4 u_ViewMatrix = mat4(1.0);
uniform ivec3 u_TileOffset = ivec3(0, 0, 0);
uniform ivec3 u_Color = ivec3(255, 0, 0);

in vec3 a_Position;
in vec3 a_Normal;
in vec2 a_UV;

out vec4 v_Position;
out vec4 v_Normal;
out vec2 v_UV;
flat out int v_Face;

const float TILE_SIZE = 1.0;
const vec3 halfOffset = vec3(0.0, 0.0, 0.0);

void main()
{
    v_Position = u_ProjectionMatrix * u_ViewMatrix * vec4((a_Position + halfOffset + vec3(u_TileOffset)) * TILE_SIZE, 1.0);
    gl_Position = v_Position;

    if (abs(1.0 - dot(a_Normal.xyz, vec3(0, 1, 0))) < 0.01)
        v_Face = 0;
    else if (abs(1.0 - dot(a_Normal.xyz, vec3(0, -1, 0))) < 0.01)
        v_Face = 1;
    else if (abs(1.0 - dot(a_Normal.xyz, vec3(1, 0, 0))) < 0.01)
        v_Face = 2;
    else if (abs(1.0 - dot(a_Normal.xyz, vec3(-1, 0, 0))) < 0.01)
        v_Face = 3;
    else if (abs(1.0 - dot(a_Normal.xyz, vec3(0, 0, 1))) < 0.01)
        v_Face = 4;
    else
        v_Face = 5;


    v_Normal = normalize(u_ProjectionMatrix * u_ViewMatrix * vec4(a_Normal, 0.0));

    v_UV = a_UV;
}